<?php
Function tableNames()
{
	$aNames=array(
		"krAree"
		,"krIscrizioni"
		,"krUtenti"
		,"krGruppi"
		,"krJournal"
		,"krSessioni"
		,"krStatus"
		,"krTipiLinks"
		,"krLinksets"
		,"krLinks"
		,"krHosts"
		,"krBots"
	);

	if ($aUsrNames = file(PTH."usrtablenames.dat"))
	{
		while (list($line_num, $sLine) = each($aUsrNames))
		{
			$aNames[]=str_replace ("\n", "", $sLine);
		}
	}

	return $aNames;
}

Function databaseRestart()
{
	$aTableNames=tableNames();
	while(list($nKey,$sTableName)=each($aTableNames))
	{
		tableDrop($sTableName);
		tableCreate($sTableName);
		tableLoad($sTableName);
	}
}

Function tableDrop($TableName)
{
	global $dsource;
	$s="DROP TABLE $TableName;";
	$i="Eliminazione tabella [$TableName]";
	$dsource->run($s,$i);
	echo $dsource->errmsg;
}

Function tableCreate($TableName)
{
	echo "<br>Creazione tabella ";
	global $dsource;
	$i="Creazione tabella $Tablename";

	$s="CREATE TABLE $TableName(";

	switch($TableName){
		case "krIscrizioni":
			echo "- ".$TableName;
			$s.="
			fkUsrIsc		char(50),
			fkGrpIsc		char(50),
			dataScadenzaIsc		date
			";
		break;
//			INDEX (fkUsrIsc),
//			INDEX (fkGrpIsc)

		case "krGruppi":
			echo "- ".$TableName;
			$s.="
			idGrp			char(50),
			desGrp			char(250)
			";
		break;

		case "krUtenti":
			echo "- ".$TableName;
			$s.="
			idUsr			char(50) not null primary key,
			nomeUsr			char(100),
			cognomeUsr		char(100),
			titoloUsr		char(10),
			emailUsr		char(250),
			indirizzoUsr		char(250),
			cittaUsr		char(100),
			provinciaUsr		char(2),
			statoUsr		char(2),
			shadowUsr		char(32)
			";
		break;

		case "krHosts":
			echo "- ".$TableName;
			$s.="
			idHst			char(64) not null primary key,
			useragentHst		char(100),
			fkLastUsrHst		char(50),
			lasttimeHst		timestamp
			";
		break;

		case "krSessioni":
			echo "- ".$TableName;
			$s.="
			idSes			bigint unsigned not null primary key auto_increment,
			sessidSes		char(64),
			fkUsrSes		char(250),
			inizioSes		timestamp,
			scadenzaSes		timestamp,
			ipSes			char(20),
			hostSes			char(250),
			fkHstSes		char(64),
			fkLastAreaSes		char(250),
			useragentSes		char(250),
			persistentDataSes	longtext
			";
		break;

		case "krBots":
			echo "- ".$TableName;
			$s.="
			idBot			bigint unsigned not null primary key auto_increment,
			desBot			char(250),
			ipBot			char(20),
			useragentBot		char(250),
			hostileBot		char(1) default 'N'
			";
		break;

		case "krJournal":
			echo "- ".$TableName;
			$s.="
			timeJou			timestamp,
			fkSesJou		bigint,
			fkUsrJou		char(250),
			referrerJou		char(255),
			requestJou		char(255),
			areaJou			char(255),
			resultJou		char(1),
			ipJou			char(20),
			hostJou			char(255)
			";
		break;

		case "krAree":
			echo "- ".$TableName;
			$s.="
			idAre			bigint unsigned not null primary key auto_increment,
			uriAre			char(250),
			dataAre			date,
			progrAre		char(14),
			titoloAre		char(250),
			titolettoAre		char(20),
			autoreAre		char(100),
			keywordsAre		char(250),
			kwOutAre		char(250),
			testoAre		longtext,
			abstractAre		longtext,
			fkStaAutAre		char(2),
			fkStaRedAre		char(2),
			styleAre		char(250),
			noCommonStyleAre	char(1) default 'N',
			languageAre		char(30) default 'Italiano',
			templateAre		char(250),
			sqlAre			longtext,
			urlAre			char(250),
			mimeAre			char(100),
			fkParentAre		char(250),
			isSectionAre		char(1) default 'N',
			fkSectionAre		char(250),
			isHomeAre		char(1) default 'N',
			fkHomeAre		char(250),
			enhLevelAre		tinyint default 0,
			inheritsLinkAre		char(1) default 'S',
			inheritsPropAre		char(1) default 'S',
			fkGrpSelectAre		char(250) default 'users',
			fkGrpUpdateAre		char(250) default 'admin',
			fkGrpAdminAre		char(250) default 'consiglio',
			timelogAre		timestamp,
			fkNomAre		char(250)
			";
		break;

		case "krStatus":
			echo "- ".$TableName;
			$s.="
			codSta  		char(2) not null primary key,
			desSta  		char(250),
			tipoSta 		char(2)
			";
		break;

		case "krTipiLinks":
			echo "- ".$TableName;
			$s.="
			codTln  		char(20) not null primary key,
			desTln  		longtext
			";
		break;

/* Aggiunti i campi fkAreRelLink e tipoRelLnk che hanno lo scopo di consentire l'inserimento di un
vincolo legato all'area all'interno della quale sar inserito il link.
In pratica, un linkset potrebbe decidere di visualizzare nello spazio a lui riservato
uno o pi links in base ai vincoli qui specificati.
*/
		case "krLinks":
			echo "- ".$TableName;
			$s.="
			idLnk			bigint unsigned not null primary key auto_increment,
			fkLksLnk		char(250),
			fkAreLnk		char(250),
			fkAreRelLnk		char(250),
			tipoRelLnk		char(250),
			progrLnk		char(20),
			urlLnk			char(250),
			keywordLnk		char(250),
			nomeLnk			char(250),
			descrizioneLnk	longtext
			";
		break;

/*Vecchio	case "krLinks":
			echo "- ".$TableName;
			$s.="
			idLnk			bigint unsigned not null primary key auto_increment,
			fkLksLnk		char(250),
			fkAreLnk		char(250),
			progrLnk		char(20),
			urlLnk			char(250),
			keywordLnk		char(250),
			nomeLnk			char(250),
			descrizioneLnk		longtext
			";
		break;
*/
		case "krLinksets":
			echo "- ".$TableName;
			$s.="
			idLks			bigint unsigned not null primary key auto_increment,
			nomeLks			char(250),
			fkTlnLks		char(20) default 'COMMON',
			sqlLks			longtext,
			titoloLks		char(250),
			descrizioneLks		longtext
			";
		break;

		default:
			if (file_exists(PTH."usrtabledefs.inc"))
			{
				include PTH."usrtabledefs.inc";
			}
			else
			{
				echo "<br>Nessuna tabella utente predefinita nel path ".PTH."usrtabledefs.inc";
				echo "<br>Non riconosciuto il nome [$TableName]";
			}
		break;
	}

	$s.=")";
	$dsource->run($s,$i);
	echo $dsource->errmsg;

}

Function tableLoad($TableName, $bViewFile=0)
{
	global $dsource;
	$tabella= $TableName; // Tabella da popolare
	$nomefile = BKP.$TableName.".txt"; // File con i dati da caricare
	$info = $tabella; // Informazione da visualizzare sull'esecuzione
	$dsource->load($tabella, $nomefile,$info);
	echo $dsource->errmsg;
	if ($bViewFile)
	{
		echo "\n<hr><pre>\n<!--Data-->\n";
		include $nomefile;
		echo "\n<!--/Data-->\n</pre><hr>";
	}
}


Function tableBackup($TableName, $sWhere="")
{
	global $dsource;
	$tabella= $TableName; // Tabella da popolare
	$nomefile = BKP.$TableName.".txt"; // File con i dati da caricare
	$info = $tabella; // Informazione da visualizzare sull'esecuzione
	dbgv("Tabella di cui leggere i campi - aamfunc.inc",$tabella);
	$dsource->save($tabella, $nomefile, $info, ";", $sWhere);
//	$dsource->export($tabella, $nomefile, $info, ";", $sWhere);
	echo $dsource->errmsg;
	echo "<br><b>$nomefile</b><br>";
	echo "\n<hr><pre>\n<!--Data-->\n";
	include $nomefile;
	echo "\n<!--/Data-->\n</pre><hr>";
}

Function tableView($TableName, $sWhere="")
{
	global $dsource;
	$tabella= $TableName; // Tabella da visualizzare
	$nomefile = BKP.$TableName.".view"; // File con i dati da visualizzare
	$info = $tabella; // Informazione da visualizzare sull'esecuzione
	$dsource->save($tabella, $nomefile, $info, ";", $sWhere);
//	$dsource->export($tabella, $nomefile, $info, ";", $sWhere);
	echo $dsource->errmsg;
	echo "<br><b>$nomefile</b><br>";
	echo "\n<hr><pre>\n<!--Data-->\n";
	include $nomefile;
	echo "\n<!--/Data-->\n</pre><hr>";
}

Function tableDelete($TableName, $sWhere="")
{
	global $dsource;
	$tabella= $TableName; // Tabella di cui eliminare dati
	$info = $tabella; // Informazione da visualizzare sull'esecuzione
	$sql=
		"DELETE FROM $TableName "
		.(($sWhere)?("WHERE $sWhere"):(""))
	;
	$dsource->run($sql);
	echo $dsource->errmsg;
	$dsource->run("OPTIMIZE TABLE $TableName");
	echo $dsource->errmsg;
}

Function areeRiallineaSezioni()
{
	global $dsource;
	global $me;
	$info = "Riallineamento krAree"; // Informazione da visualizzare sull'esecuzione



	$sql="SELECT uriAre FROM krAree;";
	$dsource->run($sql);
	echo $dsource->errmsg;

	$rcsAree= $dsource->recordset;

	while (list($key,$rArea)=each($rcsAree))
	{
		$sHome=$me->getHome($rArea[uriAre]);
		$sSezione=$me->getSection($rArea[uriAre]);
		$sql="UPDATE krAree set fkSectionAre='$sSezione', fkHomeAre='$sHome' WHERE uriAre='".$rArea[uriAre]."';";

		echo "\n<br><b>".$rArea[uriAre]."</b>: $sSezione";
		echo "\n<br><i>$sql</i>";

		$dsource->run($sql);
		echo $dsource->errmsg;
		echo "\n<br>";
	}
}
?>
